// Creating markers and export to a file by AEplug
// http://aeplug.ru/forum/viewtopic.php?t=244

var w = new Window("palette", "Add Markers v2 by AEplug");
//~ w.frameLocation = [100,100];
w.location = [100, 200];
var m_button = w.add("button", undefined, "Marker");
var mplus_button = w.add("button", undefined, "Marker-In");
var mminus_button = w.add("button", undefined, "Marker-Out");
var trans_button = w.add("button", undefined, "Marker-Trans");
var mname_button = w.add("button", undefined, "Marker-name");
var mname_dur_button = w.add("button", undefined, "Marker-name-duration");
var all_layers_button = w.add("button", undefined, "Marker selected layers in/out");
var add_layer_button = w.add("button", undefined, "Add Marker layer");
var save_button = w.add("button", undefined, "Save to file");
var save_button_new = w.add("button", undefined, "Save to CSV");

function all_layers_add_marker() {
	var myComp = app.project.activeItem;
	for (var i = 0; i < myComp.selectedLayers.length; i++) {
		myComp.time = myComp.selectedLayers[i].inPoint;
		add_marker_plus();
		myComp.time = myComp.selectedLayers[i].outPoint;
		add_marker_minus();
	}
}

function save_marker() {
	var myComp = app.project.activeItem;
	var myLayer = myComp.layer("MARKERS");
	var fps = 1 / myComp.frameDuration;
	var newFile= new File("/d/DOWNLOAD/markers to Au.txt");
	if(newFile!=null){
		newFile.open("w");
		for (i = 1; i <= myLayer.property("Marker").numKeys; i++) {
			var markerTime = myLayer.property("Marker").keyTime(i);
			var markerDur = myLayer.property("Marker").keyValue(i).duration;
			var markerEnd = myLayer.property("Marker").keyValue(i).duration+markerTime;
			var markerCom = myLayer.property("Marker").keyValue(i).comment;
			newFile.writeln(timeToCurrentFormat(markerTime, fps)+"\t"+timeToCurrentFormat(markerDur, fps)+"\t"+timeToCurrentFormat(markerEnd, fps)+"\t"+markerCom);
		}
		newFile.close();
	}
}

function save_marker_new() {
	var myComp = app.project.activeItem;
	var myLayer = myComp.layer("MARKERS");
	var fps = 1 / myComp.frameDuration;
	var newFile= new File("/d/DOWNLOAD/markers to Au.csv");
	if(newFile!=null){
		newFile.open("w");
		newFile.encoding = "UTF-8";
		newFile.lineFeed = "Windows";
		newFile.writeln("Name\tStart\tDuration\tTime Format\tType\tDescription");
		for (i = 1; i <= myLayer.property("Marker").numKeys; i++) {
			var markerTime = myLayer.property("Marker").keyTime(i);
			var markerDur = myLayer.property("Marker").keyValue(i).duration;
			var markerEnd = myLayer.property("Marker").keyValue(i).duration+markerTime;
			var markerCom = myLayer.property("Marker").keyValue(i).comment;
			newFile.writeln(markerCom+"\t"+timeToCurrentFormat(markerTime, fps)+"\t"+timeToCurrentFormat(markerDur, fps)+"\t"+fps+" fps\tCue\t");
		}
		newFile.close();
	}
}

function add_marker_name() {
	var name = prompt("Input Name for Marker", "marker name");
	if (name) {
		add_marker_str(name,0);
	}
}

function add_marker_name_dur() {
	var name = prompt("Input Name for Marker", "marker name");
	if (name) {
		add_marker_str(name,1);
	}
}

function add_marker() {
	add_marker_str("",0);
}

function add_marker_plus() {
	add_marker_str("In",0);
}

function add_marker_minus() {
	add_marker_str("Out",0);
}

function add_marker_trans() {
	add_marker_str("Trans",0);
}

function add_layer() {
	var myComp = app.project.activeItem;
	for (i = 1; i <= myComp.numLayers; i++) {
		if (myComp.layer(i).name == "MARKERS") {
			alert("MARKERS layer already exists: " + i);
			return;
		}
	}
	app.beginUndoGroup("Add MARKERS Layer");
	var activeComp = app.project.activeItem;
	var new_layer = activeComp.layers.addSolid([1, 1, 1], "MARKERS", activeComp.width, activeComp.height, activeComp.pixelAspect, activeComp.duration);
	new_layer.enabled = false;
	new_layer.moveToEnd();
	app.endUndoGroup();
}

function add_marker_str(str,dur) {
	app.beginUndoGroup("Add marker");
	var myComp = app.project.activeItem;
	var CurrentTime = myComp.time;
	var myLayer = myComp.layer("MARKERS");
	var myMarker = new MarkerValue(str);
	myMarker.duration=dur;
	myLayer.Marker.setValueAtTime(CurrentTime, myMarker);
	app.endUndoGroup();
}

m_button.onClick = add_marker;
mplus_button.onClick = add_marker_plus;
mminus_button.onClick = add_marker_minus;
trans_button.onClick = add_marker_trans;
mname_button.onClick = add_marker_name;
mname_dur_button.onClick = add_marker_name_dur;
add_layer_button.onClick = add_layer;
save_button.onClick = save_marker;
save_button_new.onClick = save_marker_new;
all_layers_button.onClick = all_layers_add_marker;

w.show();